/* Keyring.c generated by valac 0.34.7, the Vala compiler
 * generated from Keyring.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* This is compatible with Ubuntu Online Accounts.*/

#include <glib.h>
#include <glib-object.h>
#include <gsignond/gsignond-secret-storage.h>
#include <libsecret/secret.h>
#include <gsignond/gsignond-credentials.h>
#include <gsignond/gsignond-dictionary.h>
#include <stdlib.h>
#include <string.h>


#define ONLINE_ACCOUNTS_TYPE_KEYRING (online_accounts_keyring_get_type ())
#define ONLINE_ACCOUNTS_KEYRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyring))
#define ONLINE_ACCOUNTS_KEYRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringClass))
#define ONLINE_ACCOUNTS_IS_KEYRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING))
#define ONLINE_ACCOUNTS_IS_KEYRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_KEYRING))
#define ONLINE_ACCOUNTS_KEYRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringClass))

typedef struct _OnlineAccountsKeyring OnlineAccountsKeyring;
typedef struct _OnlineAccountsKeyringClass OnlineAccountsKeyringClass;
typedef struct _OnlineAccountsKeyringPrivate OnlineAccountsKeyringPrivate;

#define ONLINE_ACCOUNTS_KEYRING_TYPE_SIGNON_SECRET_TYPE (online_accounts_keyring_signon_secret_type_get_type ())
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _OnlineAccountsKeyring {
	GSignondSecretStorage parent_instance;
	OnlineAccountsKeyringPrivate * priv;
};

struct _OnlineAccountsKeyringClass {
	GSignondSecretStorageClass parent_class;
};

struct _OnlineAccountsKeyringPrivate {
	SecretSchema* schema;
	GError* error;
};

typedef enum  {
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE = 0,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA
} OnlineAccountsKeyringSignonSecretType;


static gpointer online_accounts_keyring_parent_class = NULL;

GType online_accounts_keyring_get_type (void) G_GNUC_CONST;
#define ONLINE_ACCOUNTS_KEYRING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringPrivate))
enum  {
	ONLINE_ACCOUNTS_KEYRING_DUMMY_PROPERTY
};
GType online_accounts_keyring_signon_secret_type_get_type (void) G_GNUC_CONST;
static gboolean online_accounts_keyring_real_open_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_close_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_clear_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_is_open_db (GSignondSecretStorage* base);
static GSignondCredentials* online_accounts_keyring_real_load_credentials (GSignondSecretStorage* base, guint32 id);
gboolean online_accounts_keyring_load_secret (OnlineAccountsKeyring* self, OnlineAccountsKeyringSignonSecretType type, guint32 id, guint32 method, gchar** secret);
static gboolean online_accounts_keyring_real_update_credentials (GSignondSecretStorage* base, GSignondCredentials* creds);
gboolean online_accounts_keyring_store_secret (OnlineAccountsKeyring* self, OnlineAccountsKeyringSignonSecretType type, guint32 id, guint32 method, const gchar* secret);
static gboolean online_accounts_keyring_real_remove_credentials (GSignondSecretStorage* base, guint32 id);
static gboolean online_accounts_keyring_real_check_credentials (GSignondSecretStorage* base, GSignondCredentials* creds);
static GSignondDictionary* online_accounts_keyring_real_load_data (GSignondSecretStorage* base, guint32 id, guint32 method);
static gboolean online_accounts_keyring_real_update_data (GSignondSecretStorage* base, guint32 id, guint32 method, GSignondDictionary* data);
static gboolean online_accounts_keyring_real_remove_data (GSignondSecretStorage* base, guint32 id, guint32 method);
static GError* online_accounts_keyring_real_get_last_error (GSignondSecretStorage* base);
gboolean online_accounts_keyring_store_password (OnlineAccountsKeyring* self, gint type, gint id, gint method, const gchar* password);
OnlineAccountsKeyring* online_accounts_keyring_new (void);
OnlineAccountsKeyring* online_accounts_keyring_construct (GType object_type);
static void online_accounts_keyring_finalize (GObject* obj);


GType online_accounts_keyring_signon_secret_type_get_type (void) {
	static volatile gsize online_accounts_keyring_signon_secret_type_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_keyring_signon_secret_type_type_id__volatile)) {
		static const GEnumValue values[] = {{ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE", "notype"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD", "password"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME", "username"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA", "data"}, {0, NULL, NULL}};
		GType online_accounts_keyring_signon_secret_type_type_id;
		online_accounts_keyring_signon_secret_type_type_id = g_enum_register_static ("OnlineAccountsKeyringSignonSecretType", values);
		g_once_init_leave (&online_accounts_keyring_signon_secret_type_type_id__volatile, online_accounts_keyring_signon_secret_type_type_id);
	}
	return online_accounts_keyring_signon_secret_type_type_id__volatile;
}


static gboolean online_accounts_keyring_real_open_db (GSignondSecretStorage* base) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	SecretSchema* _tmp0_ = NULL;
#line 34 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 35 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->schema;
#line 35 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_ == NULL) {
#line 129 "Keyring.c"
		SecretSchema* _tmp1_ = NULL;
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = secret_schema_new ("org pantheon.OnlineAccounts.Secrets", SECRET_SCHEMA_DONT_MATCH_NAME, "signon-type", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "signon-id", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "signon-method", SECRET_SCHEMA_ATTRIBUTE_INTEGER, NULL);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_secret_schema_unref0 (self->priv->schema);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->schema = _tmp1_;
#line 137 "Keyring.c"
	}
#line 42 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 42 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 143 "Keyring.c"
}


static gboolean online_accounts_keyring_real_close_db (GSignondSecretStorage* base) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 156 "Keyring.c"
}


static gboolean online_accounts_keyring_real_clear_db (GSignondSecretStorage* base) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
#line 49 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 169 "Keyring.c"
}


static gboolean online_accounts_keyring_real_is_open_db (GSignondSecretStorage* base) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	SecretSchema* _tmp0_ = NULL;
#line 53 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->schema;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp0_ != NULL;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 185 "Keyring.c"
}


static GSignondCredentials* online_accounts_keyring_real_load_credentials (GSignondSecretStorage* base, guint32 id) {
	OnlineAccountsKeyring * self;
	GSignondCredentials* result = NULL;
	GSignondCredentials* credidential = NULL;
	GSignondCredentials* _tmp0_ = NULL;
	gchar* username = NULL;
	gchar* password = NULL;
	guint32 _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	guint32 _tmp3_ = 0U;
	gchar* _tmp4_ = NULL;
	guint32 _tmp5_ = 0U;
#line 57 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 58 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_credentials_new ();
#line 58 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	credidential = _tmp0_;
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = id;
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, _tmp1_, (guint32) 0, &_tmp2_);
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	username = _tmp2_;
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = id;
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, _tmp3_, (guint32) 0, &_tmp4_);
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	password = _tmp4_;
#line 63 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp5_ = id;
#line 63 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	gsignond_credentials_set_data (credidential, _tmp5_, username, password);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = credidential;
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 235 "Keyring.c"
}


static gboolean online_accounts_keyring_real_update_credentials (GSignondSecretStorage* base, GSignondCredentials* creds) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	guint32 id = 0U;
	GSignondCredentials* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	gchar* password = NULL;
	GSignondCredentials* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_ = NULL;
	gchar* username = NULL;
	GSignondCredentials* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_ = NULL;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (creds != NULL, FALSE);
#line 68 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = creds;
#line 68 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = gsignond_credentials_get_id (_tmp0_);
#line 68 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	id = _tmp1_;
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = creds;
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = gsignond_credentials_get_password (_tmp2_);
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	password = _tmp4_;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp6_ = password;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp6_ != NULL) {
#line 279 "Keyring.c"
		const gchar* _tmp7_ = NULL;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = password;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 285 "Keyring.c"
	} else {
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = FALSE;
#line 289 "Keyring.c"
	}
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp5_) {
#line 293 "Keyring.c"
		guint32 _tmp8_ = 0U;
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = id;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = password;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, _tmp8_, (guint32) 0, _tmp9_);
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (!_tmp10_) {
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			result = FALSE;
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (password);
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			return result;
#line 311 "Keyring.c"
		}
	}
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp11_ = creds;
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp12_ = gsignond_credentials_get_username (_tmp11_);
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	username = _tmp13_;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp15_ = username;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp15_ != NULL) {
#line 326 "Keyring.c"
		const gchar* _tmp16_ = NULL;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp16_ = username;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp14_ = g_strcmp0 (_tmp16_, "") != 0;
#line 332 "Keyring.c"
	} else {
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp14_ = FALSE;
#line 336 "Keyring.c"
	}
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp14_) {
#line 340 "Keyring.c"
		guint32 _tmp17_ = 0U;
		const gchar* _tmp18_ = NULL;
		gboolean _tmp19_ = FALSE;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp17_ = id;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp18_ = username;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp19_ = online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, _tmp17_, (guint32) 0, _tmp18_);
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (!_tmp19_) {
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			result = FALSE;
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (username);
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (password);
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			return result;
#line 360 "Keyring.c"
		}
	}
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 371 "Keyring.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return self ? g_error_copy (self) : NULL;
#line 378 "Keyring.c"
}


static gboolean online_accounts_keyring_real_remove_credentials (GSignondSecretStorage* base, guint32 id) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 389 "Keyring.c"
	{
		gboolean _tmp0_ = FALSE;
		SecretSchema* _tmp1_ = NULL;
		guint32 _tmp2_ = 0U;
		gboolean _tmp3_ = FALSE;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = self->priv->schema;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = id;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = secret_password_clear_sync (_tmp1_, NULL, &_inner_error_, "signon-id", _tmp2_, NULL);
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = _tmp3_;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 405 "Keyring.c"
			goto __catch0_g_error;
		}
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp0_;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 412 "Keyring.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = e;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = _tmp4_->message;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:90: %s", _tmp5_);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = e;
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = _g_error_copy0 (_tmp6_);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp7_;
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 446 "Keyring.c"
	}
	__finally0:
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp8_;
#line 455 "Keyring.c"
}


static gboolean online_accounts_keyring_real_check_credentials (GSignondSecretStorage* base, GSignondCredentials* creds) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	GSignondCredentials* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 96 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 96 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (creds != NULL, FALSE);
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = creds;
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = GSIGNOND_SECRET_STORAGE_CLASS (online_accounts_keyring_parent_class)->check_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, gsignond_secret_storage_get_type (), GSignondSecretStorage), _tmp0_);
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp1_;
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 476 "Keyring.c"
}


static GSignondDictionary* online_accounts_keyring_real_load_data (GSignondSecretStorage* base, guint32 id, guint32 method) {
	OnlineAccountsKeyring * self;
	GSignondDictionary* result = NULL;
	GSignondDictionary* _result_ = NULL;
	GSignondDictionary* _tmp0_ = NULL;
	gchar* data_serialized = NULL;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_ = 0U;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 100 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 101 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_dictionary_new ();
#line 101 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_result_ = _tmp0_;
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = id;
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = method;
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, _tmp1_, _tmp2_, &_tmp3_);
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (data_serialized);
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	data_serialized = _tmp3_;
#line 104 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp4_ = data_serialized;
#line 104 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp4_ == NULL) {
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _result_;
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data_serialized);
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 517 "Keyring.c"
	}
	{
		GVariant* variant = NULL;
		const gchar* _tmp5_ = NULL;
		GVariant* _tmp6_ = NULL;
		GVariant* _tmp7_ = NULL;
		GSignondDictionary* _tmp8_ = NULL;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = data_serialized;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = g_variant_parse (NULL, _tmp5_, NULL, NULL, &_inner_error_);
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		variant = _tmp6_;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 533 "Keyring.c"
			goto __catch1_g_error;
		}
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = variant;
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = gsignond_dictionary_new_from_variant (_tmp7_);
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_hash_table_unref0 (_result_);
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_result_ = _tmp8_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_variant_unref0 (variant);
#line 546 "Keyring.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = e;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = _tmp9_->message;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:112: %s", _tmp10_);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp11_ = e;
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp12_ = _g_error_copy0 (_tmp11_);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp12_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 576 "Keyring.c"
	}
	__finally1:
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data_serialized);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_hash_table_unref0 (_result_);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return NULL;
#line 591 "Keyring.c"
	}
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _result_;
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (data_serialized);
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 599 "Keyring.c"
}


static gboolean online_accounts_keyring_real_update_data (GSignondSecretStorage* base, guint32 id, guint32 method, GSignondDictionary* data) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gchar* secret = NULL;
	GSignondDictionary* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	guint32 _tmp7_ = 0U;
	guint32 _tmp8_ = 0U;
	gboolean _tmp9_ = FALSE;
#line 119 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 119 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = data;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = gsignond_dictionary_to_variant (_tmp0_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = _tmp1_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = g_variant_print (_tmp2_, TRUE);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp4_ = _tmp3_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp5_ = g_strdup_printf ("%s", _tmp4_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp6_ = _tmp5_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (_tmp4_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_variant_unref0 (_tmp2_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	secret = _tmp6_;
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp7_ = id;
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp8_ = method;
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp9_ = online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, _tmp7_, _tmp8_, secret);
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp9_;
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (secret);
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 653 "Keyring.c"
}


static gboolean online_accounts_keyring_real_remove_data (GSignondSecretStorage* base, guint32 id, guint32 method) {
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 124 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 664 "Keyring.c"
	{
		gboolean _tmp0_ = FALSE;
		SecretSchema* _tmp1_ = NULL;
		guint32 _tmp2_ = 0U;
		guint32 _tmp3_ = 0U;
		gboolean _tmp4_ = FALSE;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = self->priv->schema;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = id;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = method;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = secret_password_clear_sync (_tmp1_, NULL, &_inner_error_, "signon-id", _tmp2_, "signon-method", _tmp3_, NULL, NULL);
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = _tmp4_;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 683 "Keyring.c"
			goto __catch2_g_error;
		}
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp0_;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 690 "Keyring.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = e;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = _tmp5_->message;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:128: %s", _tmp6_);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = e;
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = _g_error_copy0 (_tmp7_);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp8_;
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 724 "Keyring.c"
	}
	__finally2:
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp9_;
#line 733 "Keyring.c"
}


static GError* online_accounts_keyring_real_get_last_error (GSignondSecretStorage* base) {
	OnlineAccountsKeyring * self;
	GError* result = NULL;
	GError* _tmp0_ = NULL;
	GError* _tmp1_ = NULL;
#line 134 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->error;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = _g_error_copy0 (_tmp0_);
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp1_;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 752 "Keyring.c"
}


gboolean online_accounts_keyring_store_password (OnlineAccountsKeyring* self, gint type, gint id, gint method, const gchar* password) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 138 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = password;
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp1_ == NULL) {
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = TRUE;
#line 772 "Keyring.c"
	} else {
		const gchar* _tmp2_ = NULL;
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = password;
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 779 "Keyring.c"
	}
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_) {
#line 140 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 140 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 787 "Keyring.c"
	}
	{
		gboolean _tmp3_ = FALSE;
		SecretSchema* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = self->priv->schema;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = password;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = type;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = id;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = method;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = secret_password_store_sync (_tmp4_, SECRET_COLLECTION_DEFAULT, "Online Account", _tmp5_, NULL, &_inner_error_, "signon-type", _tmp6_, "signon-id", _tmp7_, "signon-method", _tmp8_, NULL, NULL);
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = _tmp9_;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 813 "Keyring.c"
			goto __catch3_g_error;
		}
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp3_;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 820 "Keyring.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = e;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp11_ = _tmp10_->message;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:147: %s", _tmp11_);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp12_ = e;
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp13_ = _g_error_copy0 (_tmp12_);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp13_;
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 854 "Keyring.c"
	}
	__finally3:
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp14_;
#line 863 "Keyring.c"
}


gboolean online_accounts_keyring_store_secret (OnlineAccountsKeyring* self, OnlineAccountsKeyringSignonSecretType type, guint32 id, guint32 method, const gchar* secret) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gchar* display_name = NULL;
	guint32 _tmp3_ = 0U;
	OnlineAccountsKeyringSignonSecretType _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	OnlineAccountsKeyringSignonSecretType _tmp7_ = 0;
	gchar* signonMethod = NULL;
	gchar* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
#line 153 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = secret;
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp1_ == NULL) {
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = TRUE;
#line 890 "Keyring.c"
	} else {
		const gchar* _tmp2_ = NULL;
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = secret;
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 897 "Keyring.c"
	}
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_) {
#line 155 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 155 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 905 "Keyring.c"
	}
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = id;
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp4_ = type;
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp5_ = g_strdup_printf ("Online Account: id %u-%u", (guint) _tmp3_, (guint) _tmp4_);
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	display_name = _tmp5_;
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp7_ = type;
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp7_ == ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA) {
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = "signon-method";
#line 921 "Keyring.c"
	} else {
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = NULL;
#line 925 "Keyring.c"
	}
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	signonMethod = _tmp8_;
#line 931 "Keyring.c"
	{
		SecretSchema* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		OnlineAccountsKeyringSignonSecretType _tmp12_ = 0;
		guint32 _tmp13_ = 0U;
		const gchar* _tmp14_ = NULL;
		guint32 _tmp15_ = 0U;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = self->priv->schema;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = display_name;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp11_ = secret;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp12_ = type;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp13_ = id;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp14_ = signonMethod;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp15_ = method;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		secret_password_store_sync (_tmp9_, SECRET_COLLECTION_DEFAULT, _tmp10_, _tmp11_, NULL, &_inner_error_, "signon-type", _tmp12_, "signon-id", _tmp13_, _tmp14_, _tmp15_, NULL);
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 958 "Keyring.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		GError* _tmp19_ = NULL;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp16_ = e;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp17_ = _tmp16_->message;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:164: %s", _tmp17_);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp18_ = e;
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp19_ = _g_error_copy0 (_tmp18_);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp19_;
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (display_name);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 998 "Keyring.c"
	}
	__finally4:
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1003 "Keyring.c"
		gboolean _tmp20_ = FALSE;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (display_name);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return _tmp20_;
#line 1015 "Keyring.c"
	}
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (signonMethod);
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (display_name);
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 1025 "Keyring.c"
}


gboolean online_accounts_keyring_load_secret (OnlineAccountsKeyring* self, OnlineAccountsKeyringSignonSecretType type, guint32 id, guint32 method, gchar** secret) {
	gchar* _vala_secret = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	OnlineAccountsKeyringSignonSecretType _tmp1_ = 0;
	gchar* signonMethod = NULL;
	gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = type;
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp1_ == ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA) {
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = "signon-method";
#line 1045 "Keyring.c"
	} else {
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = NULL;
#line 1049 "Keyring.c"
	}
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	signonMethod = _tmp2_;
#line 1055 "Keyring.c"
	{
		gchar* data = NULL;
		SecretSchema* _tmp3_ = NULL;
		OnlineAccountsKeyringSignonSecretType _tmp4_ = 0;
		guint32 _tmp5_ = 0U;
		const gchar* _tmp6_ = NULL;
		guint32 _tmp7_ = 0U;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = self->priv->schema;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = type;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = id;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = signonMethod;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = method;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = secret_password_lookup_sync (_tmp3_, NULL, &_inner_error_, "signon-type", _tmp4_, "signon-id", _tmp5_, _tmp6_, _tmp7_, NULL);
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		data = _tmp8_;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1082 "Keyring.c"
			goto __catch5_g_error;
		}
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = data;
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_vala_secret = _tmp10_;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data);
#line 1095 "Keyring.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		GError* _tmp14_ = NULL;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp11_ = e;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp12_ = _tmp11_->message;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_warning ("Keyring.vala:180: %s", _tmp12_);
#line 181 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 181 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_vala_secret = NULL;
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp13_ = e;
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp14_ = _g_error_copy0 (_tmp13_);
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp14_;
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (secret) {
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			*secret = _vala_secret;
#line 1137 "Keyring.c"
		} else {
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (_vala_secret);
#line 1141 "Keyring.c"
		}
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 1145 "Keyring.c"
	}
	__finally5:
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1150 "Keyring.c"
		gboolean _tmp15_ = FALSE;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return _tmp15_;
#line 1160 "Keyring.c"
	}
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (signonMethod);
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (secret) {
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		*secret = _vala_secret;
#line 1170 "Keyring.c"
	} else {
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 1174 "Keyring.c"
	}
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 1178 "Keyring.c"
}


OnlineAccountsKeyring* online_accounts_keyring_construct (GType object_type) {
	OnlineAccountsKeyring * self = NULL;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return self;
#line 1188 "Keyring.c"
}


OnlineAccountsKeyring* online_accounts_keyring_new (void) {
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return online_accounts_keyring_construct (ONLINE_ACCOUNTS_TYPE_KEYRING);
#line 1195 "Keyring.c"
}


static void online_accounts_keyring_class_init (OnlineAccountsKeyringClass * klass) {
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_type_class_add_private (klass, sizeof (OnlineAccountsKeyringPrivate));
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->open_db = (gboolean (*)(GSignondSecretStorage*)) online_accounts_keyring_real_open_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->close_db = (gboolean (*)(GSignondSecretStorage*)) online_accounts_keyring_real_close_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->clear_db = (gboolean (*)(GSignondSecretStorage*)) online_accounts_keyring_real_clear_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->is_open_db = (gboolean (*)(GSignondSecretStorage*)) online_accounts_keyring_real_is_open_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->load_credentials = (GSignondCredentials* (*)(GSignondSecretStorage*, guint32)) online_accounts_keyring_real_load_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->update_credentials = (gboolean (*)(GSignondSecretStorage*, GSignondCredentials*)) online_accounts_keyring_real_update_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->remove_credentials = (gboolean (*)(GSignondSecretStorage*, guint32)) online_accounts_keyring_real_remove_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->check_credentials = (gboolean (*)(GSignondSecretStorage*, GSignondCredentials*)) online_accounts_keyring_real_check_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->load_data = (GSignondDictionary* (*)(GSignondSecretStorage*, guint32, guint32)) online_accounts_keyring_real_load_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->update_data = (gboolean (*)(GSignondSecretStorage*, guint32, guint32, GSignondDictionary*)) online_accounts_keyring_real_update_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->remove_data = (gboolean (*)(GSignondSecretStorage*, guint32, guint32)) online_accounts_keyring_real_remove_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->get_last_error = (GError* (*)(GSignondSecretStorage*)) online_accounts_keyring_real_get_last_error;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_keyring_finalize;
#line 1230 "Keyring.c"
}


static void online_accounts_keyring_instance_init (OnlineAccountsKeyring * self) {
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv = ONLINE_ACCOUNTS_KEYRING_GET_PRIVATE (self);
#line 32 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv->schema = NULL;
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv->error = NULL;
#line 1241 "Keyring.c"
}


static void online_accounts_keyring_finalize (GObject* obj) {
	OnlineAccountsKeyring * self;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyring);
#line 32 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_secret_schema_unref0 (self->priv->schema);
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_error_free0 (self->priv->error);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	G_OBJECT_CLASS (online_accounts_keyring_parent_class)->finalize (obj);
#line 1255 "Keyring.c"
}


GType online_accounts_keyring_get_type (void) {
	static volatile gsize online_accounts_keyring_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_keyring_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsKeyringClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_keyring_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsKeyring), 0, (GInstanceInitFunc) online_accounts_keyring_instance_init, NULL };
		GType online_accounts_keyring_type_id;
		online_accounts_keyring_type_id = g_type_register_static (gsignond_secret_storage_get_type (), "OnlineAccountsKeyring", &g_define_type_info, 0);
		g_once_init_leave (&online_accounts_keyring_type_id__volatile, online_accounts_keyring_type_id);
	}
	return online_accounts_keyring_type_id__volatile;
}



