/* StorageManager.c generated by valac 0.34.7, the Vala compiler
 * generated from StorageManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gsignond/gsignond-storage-manager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <sys/stat.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gsignond/gsignond-config.h>


#define ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER (online_accounts_storage_manager_get_type ())
#define ONLINE_ACCOUNTS_STORAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER, OnlineAccountsStorageManager))
#define ONLINE_ACCOUNTS_STORAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER, OnlineAccountsStorageManagerClass))
#define ONLINE_ACCOUNTS_IS_STORAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER))
#define ONLINE_ACCOUNTS_IS_STORAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER))
#define ONLINE_ACCOUNTS_STORAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER, OnlineAccountsStorageManagerClass))

typedef struct _OnlineAccountsStorageManager OnlineAccountsStorageManager;
typedef struct _OnlineAccountsStorageManagerClass OnlineAccountsStorageManagerClass;
typedef struct _OnlineAccountsStorageManagerPrivate OnlineAccountsStorageManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _OnlineAccountsStorageManager {
	GSignondStorageManager parent_instance;
	OnlineAccountsStorageManagerPrivate * priv;
};

struct _OnlineAccountsStorageManagerClass {
	GSignondStorageManagerClass parent_class;
};


static gpointer online_accounts_storage_manager_parent_class = NULL;

GType online_accounts_storage_manager_get_type (void) G_GNUC_CONST;
enum  {
	ONLINE_ACCOUNTS_STORAGE_MANAGER_DUMMY_PROPERTY
};
static gboolean online_accounts_storage_manager_real_initialize_storage (GSignondStorageManager* base);
static gboolean online_accounts_storage_manager_real_delete_storage (GSignondStorageManager* base);
static gboolean online_accounts_storage_manager_real_storage_is_initialized (GSignondStorageManager* base);
static const gchar* online_accounts_storage_manager_real_mount_filesystem (GSignondStorageManager* base);
static gboolean online_accounts_storage_manager_real_unmount_filesystem (GSignondStorageManager* base);
static gboolean online_accounts_storage_manager_real_filesystem_is_mounted (GSignondStorageManager* base);
OnlineAccountsStorageManager* online_accounts_storage_manager_new (void);
OnlineAccountsStorageManager* online_accounts_storage_manager_construct (GType object_type);
static GObject * online_accounts_storage_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);


static gboolean online_accounts_storage_manager_real_initialize_storage (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 39 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 40 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = ((GSignondStorageManager*) self)->location;
#line 40 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp1_ = g_mkdir_with_parents (_tmp0_, ((gint) S_IRWXU) | S_IRWXG);
#line 40 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	result = _tmp1_ == 0;
#line 40 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return result;
#line 95 "StorageManager.c"
}


static gboolean online_accounts_storage_manager_real_delete_storage (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	gboolean result = FALSE;
	GFile* file = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gboolean _tmp4_ = FALSE;
	GError * _inner_error_ = NULL;
#line 43 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 44 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = ((GSignondStorageManager*) self)->location;
#line 44 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 44 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	file = _tmp1_;
#line 115 "StorageManager.c"
	{
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		g_file_delete (file, NULL, &_inner_error_);
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 121 "StorageManager.c"
			goto __catch6_g_error;
		}
#line 47 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		result = TRUE;
#line 47 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_object_unref0 (file);
#line 47 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		return result;
#line 130 "StorageManager.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		e = _inner_error_;
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_inner_error_ = NULL;
#line 49 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp2_ = e;
#line 49 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp3_ = _tmp2_->message;
#line 49 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		g_critical ("StorageManager.vala:49: %s", _tmp3_);
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		result = FALSE;
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_error_free0 (e);
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_object_unref0 (file);
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		return result;
#line 156 "StorageManager.c"
	}
	__finally6:
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_g_object_unref0 (file);
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	g_clear_error (&_inner_error_);
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return _tmp4_;
#line 167 "StorageManager.c"
}


static gboolean online_accounts_storage_manager_real_storage_is_initialized (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 55 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = ((GSignondStorageManager*) self)->location;
#line 55 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp1_ = access (_tmp0_, F_OK);
#line 55 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	result = _tmp1_ == 0;
#line 55 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return result;
#line 186 "StorageManager.c"
}


static const gchar* online_accounts_storage_manager_real_mount_filesystem (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	const gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
#line 58 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 59 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = ((GSignondStorageManager*) self)->location;
#line 59 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	result = _tmp0_;
#line 59 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return result;
#line 202 "StorageManager.c"
}


static gboolean online_accounts_storage_manager_real_unmount_filesystem (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	gboolean result = FALSE;
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 63 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	result = TRUE;
#line 63 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return result;
#line 215 "StorageManager.c"
}


static gboolean online_accounts_storage_manager_real_filesystem_is_mounted (GSignondStorageManager* base) {
	OnlineAccountsStorageManager * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 66 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) base;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = gsignond_storage_manager_storage_is_initialized ((GSignondStorageManager*) self);
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	result = _tmp0_;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return result;
#line 231 "StorageManager.c"
}


OnlineAccountsStorageManager* online_accounts_storage_manager_construct (GType object_type) {
	OnlineAccountsStorageManager * self = NULL;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = (OnlineAccountsStorageManager*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return self;
#line 241 "StorageManager.c"
}


OnlineAccountsStorageManager* online_accounts_storage_manager_new (void) {
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return online_accounts_storage_manager_construct (ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER);
#line 248 "StorageManager.c"
}


static GObject * online_accounts_storage_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	OnlineAccountsStorageManager * self;
	gchar* try_location = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* user_dir = NULL;
	gchar* _tmp2_ = NULL;
	GSignondConfig* _tmp3_ = NULL;
	GSignondConfig* _tmp4_ = NULL;
	GSignondConfig* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_ = NULL;
	const gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	parent_class = G_OBJECT_CLASS (online_accounts_storage_manager_parent_class);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_STORAGE_MANAGER, OnlineAccountsStorageManager);
#line 25 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 25 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 25 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	try_location = _tmp1_;
#line 26 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp2_ = g_strdup ("gsignond");
#line 26 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	user_dir = _tmp2_;
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	g_object_get ((GSignondStorageManager*) self, "config", &_tmp3_, NULL);
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp4_ = _tmp3_;
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp5_ = _tmp4_;
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp6_ = _tmp5_ != NULL;
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_g_object_unref0 (_tmp5_);
#line 27 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	if (_tmp6_) {
#line 299 "StorageManager.c"
		GSignondConfig* _tmp7_ = NULL;
		GSignondConfig* _tmp8_ = NULL;
		GSignondConfig* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		g_object_get ((GSignondStorageManager*) self, "config", &_tmp7_, NULL);
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp8_ = _tmp7_;
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp9_ = _tmp8_;
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp10_ = gsignond_config_get_string (_tmp9_, "General/StoragePath");
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_free0 (try_location);
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		try_location = _tmp11_;
#line 28 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_object_unref0 (_tmp9_);
#line 321 "StorageManager.c"
	}
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp14_ = try_location;
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	if (g_strcmp0 (_tmp14_, "/var/db") != 0) {
#line 327 "StorageManager.c"
		const gchar* _tmp15_ = NULL;
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp15_ = try_location;
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp13_ = g_strcmp0 (_tmp15_, "") == 0;
#line 333 "StorageManager.c"
	} else {
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp13_ = FALSE;
#line 337 "StorageManager.c"
	}
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	if (_tmp13_) {
#line 341 "StorageManager.c"
		const gchar* _tmp16_ = NULL;
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp16_ = try_location;
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp12_ = _tmp16_ == NULL;
#line 347 "StorageManager.c"
	} else {
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp12_ = FALSE;
#line 351 "StorageManager.c"
	}
#line 30 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	if (_tmp12_) {
#line 355 "StorageManager.c"
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 31 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp17_ = g_get_user_name ();
#line 31 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp18_ = g_strdup_printf ("gsignond.%s", _tmp17_);
#line 31 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_free0 (user_dir);
#line 31 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		user_dir = _tmp18_;
#line 366 "StorageManager.c"
	} else {
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp19_ = g_get_user_config_dir ();
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		_g_free0 (try_location);
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
		try_location = _tmp20_;
#line 378 "StorageManager.c"
	}
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp21_ = try_location;
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp22_ = user_dir;
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_tmp23_ = g_build_filename (_tmp21_, _tmp22_, NULL);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_g_free0 (((GSignondStorageManager*) self)->location);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManager*) self)->location = _tmp23_;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_g_free0 (user_dir);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	_g_free0 (try_location);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	return obj;
#line 396 "StorageManager.c"
}


static void online_accounts_storage_manager_class_init (OnlineAccountsStorageManagerClass * klass) {
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	online_accounts_storage_manager_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->initialize_storage = (gboolean (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_initialize_storage;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->delete_storage = (gboolean (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_delete_storage;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->storage_is_initialized = (gboolean (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_storage_is_initialized;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->mount_filesystem = (const gchar* (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_mount_filesystem;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->unmount_filesystem = (gboolean (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_unmount_filesystem;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	((GSignondStorageManagerClass *) klass)->filesystem_is_mounted = (gboolean (*)(GSignondStorageManager*)) online_accounts_storage_manager_real_filesystem_is_mounted;
#line 23 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/StorageManager.vala"
	G_OBJECT_CLASS (klass)->constructor = online_accounts_storage_manager_constructor;
#line 417 "StorageManager.c"
}


static void online_accounts_storage_manager_instance_init (OnlineAccountsStorageManager * self) {
}


GType online_accounts_storage_manager_get_type (void) {
	static volatile gsize online_accounts_storage_manager_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_storage_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsStorageManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_storage_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsStorageManager), 0, (GInstanceInitFunc) online_accounts_storage_manager_instance_init, NULL };
		GType online_accounts_storage_manager_type_id;
		online_accounts_storage_manager_type_id = g_type_register_static (gsignond_storage_manager_get_type (), "OnlineAccountsStorageManager", &g_define_type_info, 0);
		g_once_init_leave (&online_accounts_storage_manager_type_id__volatile, online_accounts_storage_manager_type_id);
	}
	return online_accounts_storage_manager_type_id__volatile;
}



