// -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-
/*-
 * Copyright (c) 2013-2016 elementary LLC.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

public class OnlineAccounts.Extension : GSignond.Extension {
    OnlineAccounts.Keyring keyring;
    OnlineAccounts.StorageManager storage_manager;

    public override unowned string get_extension_name () {
        return "pantheon";
    }

    public override uint32 get_extension_version () {
        return 0;
    }

    public override unowned GSignond.StorageManager get_storage_manager (GSignond.Config config) {
        if (storage_manager == null) {
            storage_manager = (OnlineAccounts.StorageManager)GLib.Object.new (typeof(OnlineAccounts.StorageManager), "config", config, null);
        }

        return storage_manager;
    }

    public override unowned GSignond.SecretStorage get_secret_storage (GSignond.Config config) {
        if (keyring == null) {
            keyring = new OnlineAccounts.Keyring ();
            keyring.open_db ();
        }

        return keyring;
    }

    public override unowned GSignond.AccessControlManager get_access_control_manager (GSignond.Config config) {
        return base.get_access_control_manager (config);
    }
}

static GSignond.Extension test_extension = null;
GSignond.Extension pantheon_extension_init () {
    if (test_extension == null) {
        test_extension = new OnlineAccounts.Extension ();
    }
    return test_extension;
}
